# -*- coding: utf-8 -*-
"""
Il modulo contiene tutte le strutture dati necessarie per gestire
dei player web.
"""
import os
from subprocess import Popen

DEFAULT_USER_AGENT = "Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.9.1.3) Gecko/20090910 Firefox/3.5.3"

class Player() :
    """
    La classe Player rappresenta un programma "riproduttore". Serve ad impostare
    percorso del riproduttore e le varie opzioni.

    @ivar _uri : Percorso del riproduttore di file desiderato.
    @ivar _options : Parametri da dare al player.
    @ivar _user_agent : User Agent del player.
    """
    _uri = "vlc"
    _options = "--http-user-agent"
    _user_agent = DEFAULT_USER_AGENT
    
    def __init__(self, uri="vlc", options="--http-user-agent", user_agent=DEFAULT_USER_AGENT) :
        self._uri = uri
        self._options = options
        self._user_agent = user_agent
        
    def play(self, url) :
        """
        Avvia la riproduzione dell'url specificato con il player attuale.
        
        @param url: Indirizzo remoto del flusso video/audio da riprodurre.
        @type url: String.
        """
        if self._uri=="totem":
            os.system("killall totem")
          #  p = Popen([self._uri, url])
            os.system(self._uri+" \""+url+"\" &")
        elif self._uri=="mplayer":
            os.system("killall mplayer")
          #  p = Popen([self._uri,"-user-agent",self._user_agent, url])
            os.system(self._uri+" -user-agent \""+self._user_agent+"\" \""+url+"\" &")
        elif self._uri=="mplayerRAI":
            os.system("killall mplayer")
          #  p = Popen(["mplayer","-user-agent",self._user_agent,"-playlist", url])
            os.system("mplayer -user-agent \""+self._user_agent+"\" -playlist \""+url+"\" &")
        elif self._uri=="vlc":
            os.system("killall vlc")
          #  p = Popen([self._uri, self._options, self._user_agent, url])
            os.system(self._uri+" "+self._options+" \""+self._user_agent+"\" \""+url+"\" &")
        else:
			os.system(self._uri+" \""+url+"\" &")
        
