# -*- coding: utf-8 -*-
import urllib
from xml.dom import minidom
import string
import gtk
import threading

import datetime
import os


class ThreadXML(threading.Thread):
    def __init__(self, model, statusbar, combobox):
        threading.Thread.__init__(self)
        self.model = model
        self.statusbar = statusbar
        self.combobox = combobox
        self.combobox.set_button_sensitivity(gtk.SENSITIVITY_OFF)

    def run(self):
		
        home = os.path.expanduser('~')
        self.config_dir = home +'/.tvplayer'
        os.system("python libradiotv/rai_XML.py")
        gtk.gdk.threads_enter()
        self.model.clear()
        self.file = open(self.config_dir +'/RAI_xml.list', 'r')
        for i in range (39):
            self.file.readline()
        for line in self.file.readlines() :
            temp = line.split('~')
            self.model.append([temp[0],temp[1][:-1]])
        self.file.close()
        
        self.statusbar.push(1,"Lista Registrazioni Rai aggiornata")
        self.combobox.set_button_sensitivity(gtk.SENSITIVITY_ON)
        gtk.gdk.threads_leave()
       
class ThreadXML_la7(threading.Thread):
    def __init__(self, model, statusbar, combobox):
        threading.Thread.__init__(self)
        self.model = model
        self.statusbar = statusbar
        self.combobox = combobox
        self.combobox.set_button_sensitivity(gtk.SENSITIVITY_OFF)

    def run(self):
        self.now=datetime.date.today()
        self.rtmpurl="rtmp://yalpvod.alice.cdn.interbusiness.it:1935/vod"
		#http://www.la7.tv/xml/cult/index.xml

        self.webXMLfile = urllib.urlopen("http://www.la7.tv/xml/epg/index.xml")

        self.xmldoc = minidom.parse(self.webXMLfile)

        self.webXMLfile.close()

        self.showlist = self.xmldoc.getElementsByTagName('show')

        self.cont=1
        home = os.path.expanduser('~')
        self.config_dir = home +'/.tvplayer/la7image'

        gtk.gdk.threads_enter()
        self.model.clear()

        for i in self.showlist:
            self.itemlist = i.getElementsByTagName("item")
            self.logo = i.getElementsByTagName("logo")
            self.urlimage = self.logo[0].attributes["src"].value
			#print self.urlimage
			
            self.imagefile = urllib.urlopen(self.urlimage)
            self.localFile = open(os.path.expanduser(self.config_dir + '/'+str(self.cont)+'.jpg'), 'w+')
            self.localFile.write(self.imagefile.read())
            self.imagefile.close()
            self.localFile.close()
            
            self.image = gtk.gdk.pixbuf_new_from_file(self.config_dir + '/'+str(self.cont)+'.jpg')
			
            for j in self.itemlist:
                self.titlelist = j.getElementsByTagName("title")
				#print titlelist
                self.titolo = self.titlelist[0].toxml()[7:-8]
				#url = j.attributes["linkUrl"].value
				#print url
                self.xmlurl = j.attributes["xmlURL"].value

                self.webXMLfile = urllib.urlopen(self.xmlurl)
   
                self.xmldoc2 = minidom.parse(self.webXMLfile)

                self.webXMLfile.close()
                self.description = self.xmldoc2.getElementsByTagName('description')
                self.descrizione = self.description[0].toxml()[13:-14]
				
                self.fms = self.xmldoc2.getElementsByTagName('fms')
               # print self.rtmpurl+self.fms[1].toxml()[9:-6]


                self.diff = datetime.timedelta(days=int(j.attributes["pos"].value)-6)
                self.data = self.now+self.diff
                self.model.append([self.image,"<b>"+self.titolo.encode("iso-8859-1")+"</b>\n<i>"+self.descrizione.encode("iso-8859-1")+"</i>\n<span foreground='blue'><small>DATA: "+str(self.data)+"</small></span>",self.rtmpurl+self.fms[1].toxml()[9:-6]])
                gtk.gdk.threads_leave()
            self.cont+=1
        self.combobox.set_button_sensitivity(gtk.SENSITIVITY_ON)
        self.statusbar.push(1,"Lista Registrazioni La7: 'La Settimana' aggiornata")
            
            
class ThreadXML_la7Cult(threading.Thread):
    def __init__(self, model, statusbar, combobox):
        threading.Thread.__init__(self)
        self.model = model
        self.statusbar = statusbar
        self.combobox = combobox
        self.combobox.set_button_sensitivity(gtk.SENSITIVITY_OFF)

    def run(self):
        self.rtmpurl="rtmp://yalpvod.alice.cdn.interbusiness.it:1935/vod"

        self.webXMLfile = urllib.urlopen("http://www.la7.tv/xml/cult/index.xml")

        self.xmldoc = minidom.parse(self.webXMLfile)

        self.webXMLfile.close()

        self.showlist = self.xmldoc.getElementsByTagName('show')

        self.cont=1
        home = os.path.expanduser('~')
        self.config_dir = home +'/.tvplayer/la7image/cult'

        gtk.gdk.threads_enter()
        self.model.clear()

        for i in self.showlist:
            self.itemlist = i.getElementsByTagName("item")
            self.logo = i.getElementsByTagName("logo")
            self.urlimage = self.logo[0].attributes["src"].value
			#print self.urlimage
			
            self.imagefile = urllib.urlopen(self.urlimage)
            self.localFile = open(os.path.expanduser(self.config_dir + '/'+str(self.cont)+'.jpg'), 'w+')
            self.localFile.write(self.imagefile.read())
            self.imagefile.close()
            self.localFile.close()
            
            self.image = gtk.gdk.pixbuf_new_from_file(self.config_dir + '/'+str(self.cont)+'.jpg')
			
            for j in self.itemlist:
                self.titlelist = j.getElementsByTagName("title")
				#print titlelist
                self.titolo = self.titlelist[0].toxml()[7:-8]
				#url = j.attributes["linkUrl"].value
				#print url
                self.xmlurl = j.attributes["xmlURL"].value

                self.webXMLfile = urllib.urlopen(self.xmlurl)
   
                self.xmldoc2 = minidom.parse(self.webXMLfile)

                self.webXMLfile.close()
                self.description = self.xmldoc2.getElementsByTagName('description')
                self.descrizione = self.description[0].toxml()[13:-14]
				
                self.fms = self.xmldoc2.getElementsByTagName('fms')
               # print self.rtmpurl+self.fms[1].toxml()[9:-6]
              
                self.model.append([self.image,"<b>"+self.titolo.encode("iso-8859-1")+"</b>\n<i>"+self.descrizione.encode("iso-8859-1")+"</i>",self.rtmpurl+self.fms[1].toxml()[9:-6]])
                gtk.gdk.threads_leave()
            self.cont+=1
        self.combobox.set_button_sensitivity(gtk.SENSITIVITY_ON)
        self.statusbar.push(1,"Lista Registrazioni La7: 'Archivio Cult' aggiornata")


